
//回调函数字典
var responseCallbacks = {}; 
var responseCallbacksIdArray = [];
//回调计数
var uniqueId = 1;


//
// web调用native方法 并 回调函数
// @param functionName native 函数的方法名称
// @param param 调用参数
// @param callback 回调函数
///
function callNative(functionName, param, callback){
    callNativeMutilParams(functionName, callback, param);
}

//
// web调用native方法 并 回调函数
// @param functionName native 函数的方法名称
// @param params 调用参数(可变个数, 可以为null, 或者不写)
// @param callback 回调函数 若果不需要回调, 则传 null
///
function callNativeMutilParams(functionName, callback, params){

    var jsonarray= [];

    var callbackId = "";
    if(callback != null){
        callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
        responseCallbacks[callbackId] = callback;
        responseCallbacksIdArray.push(callbackId);
    }

    if (arguments.length > 2){
        for (var i = 2; i < arguments.length; i++) {
            var arg = arguments[i];
            if (typeof arg === 'function'){
                arg = arg.toString();
            }else if(typeof arg === 'object'){
                for(var key in arg){
                    var value = arg[key];
                    if(typeof value === 'function'){
                        arg[key] = value.toString();
                    }
                }
            }

            var jsonElement= {};
            jsonElement["param"] = arg;
            jsonarray.push(jsonElement);
        }
    }
    var jsonarray =  eval(jsonarray);
    var param = JSON.stringify(jsonarray);
    window.mivi.callNative(functionName, param, callbackId);
}

/////
// native -> web
// nativie 回调web, 该回调是由于web 调用了callNative 传入了callback
// @param callbackId 回调函数ID
// @param param 回调参数
// @return
///
function __callBackToJS(callbackId, param){
    var callback = responseCallbacks[callbackId];
    if (callback === null){
        alert("callbackID: " + callbackId + "not find...");
        return;
    }
    if (arguments.length > 2){
        callback(param, arguments[2])
    }else{
        callback(param);
    }

    if(responseCallbacksIdArray.length > 200){
        delete responseCallbacks[responseCallbacksIdArray.shift()];
    }


}

/////
// Native调用JS 的函数并 回调函数
// @param callbackId 回调函数ID
// @param param 回调参数
// @return
///
function __NativeCallAndCallback(functionName, param, callbackId){
    var property = functionName;
    var parameter = [param];
    var fn = this[property];
    try {
        var res = fn.apply(this, parameter);
        //执行回调
        if (callbackId != null){
            callNativeMutilParams("__callBackToNative", null, callbackId, res);
        }
    } catch(e) {
        console.info(e);
        callNativeMutilParams("__callBackToNative", null, callbackId, 0);
    }
}

/////
// Native调用JS 检查函数是否存在, 存在 返回 1, 否则返回0
// @return 存在调用该函数, 并返回 true, 否则返回false
///
function __NativeCheckFunction(functionName){
    var property = functionName;
    var fn = this[property];
    if(typeof fn === 'function') {
        return 1;
    }else{
        return 0;
    }
}


function toastMessage(message) {
    window.mivi.toastMessage(message)
}